/*************************************************  Product Functions Header  **************************************************

	Red Rapids
	797 North Grove Rd
	Suite 101
	Richardson, TX 75081
	www.redrapids.com | support@redrapids.com

	Copyright 2014, Red Rapids, Inc.

*************************************************  Product Functions Header  **************************************************/

#ifndef _PRODUCT_FUNCTIONS_H_
#define _PRODUCT_FUNCTIONS_H_

#if defined(__cplusplus)
	extern "C" {
#endif

// Structure to reference all of the device configuration settings for a Model 377.
typedef struct
{
	s_AD9512 ClockDist;
	s_ADS42LB69 RX1TO2_ADC;
	s_LTC1661 RX1_TRIM_DAC;
	s_LTC1661 RX2_TRIM_DAC;
	s_ADL5566 RX1TO2_AMP_ENBL;
	s_ADF4110 Synthesizer;
} s_M271Devices;

// Structure to reference all of the device configuration settings for a Model 376.
typedef struct
{
	s_ADC12D1600 RX1TO2_ADC;
	s_LTC1661 RX1_TRIM_DAC;
	s_LTC1661 RX2_TRIM_DAC;
	s_ADL5566 RX1TO2_AMP_ENBL;
} s_M276Devices;

// Structure to reference all of the device configuration settings for a Model 377.
typedef struct
{
	s_AD9512 ClockDist;
	s_ADS42LB69 RX1TO2_ADC;
	s_ADS42LB69 RX3TO4_ADC;
	s_LTC1661 RX1_TRIM_DAC;
	s_LTC1661 RX2_TRIM_DAC;
	s_LTC1661 RX3_TRIM_DAC;
	s_LTC1661 RX4_TRIM_DAC;
	s_ADL5566 RX1TO2_AMP_ENBL;
	s_ADL5566 RX3TO4_AMP_ENBL;
	s_ADF4110 Synthesizer;
} s_M277Devices;

// Prototypes for each of the device functions.
unsigned long M271Initialize(s_Adapter *p_HW, s_M271Devices M271Devices, s_Channel *p_RXChannel);
unsigned long M276Initialize(s_Adapter *p_HW, s_M276Devices M276Devices, s_Channel *p_RXChannel);
unsigned long M277Initialize(s_Adapter *p_HW, s_M277Devices M277Devices, s_Channel *p_RXChannel);

#ifdef __cplusplus
}
#endif

#endif
